<template>
  <div class="feed-summary-container">
    <div class="feed-summary-inner">
      <div class="left-side-menu">
        <project-side-menu :menuTree="menuTreeList" :menuOptions="menuOptions" :unique-opened="false" :default-active="defaultActive"
          @select="menuSelect">
          <template slot="房建类成本科目-1">
            <img src="@/assets/images/projectCostLedger/icon_cost_detail_2.svg" alt="">
            <div class="project-sub-menu-title-text">房建类成本科目</div>
          </template>
          <template slot="未归类项目-1">
            <img src="@/assets/images/projectCostLedger/icon_cost_detail_3.svg" alt="">
            <div class="project-sub-menu-title-text">未归类项目</div>
          </template>
        </project-side-menu>
      </div>
      <div class="right-table-list-container">
        <div class="project-table-list-header">
          <div class="project-table-list-haeder-left">
            <el-date-picker v-model="recordDate" type="month" placeholder="选择月" format="yyyy年MM月" value-format="yyyy-MM"
              class="project-record-date" @change="timeChange"></el-date-picker>
          </div>
          <div class="project-table-list-haeder-right">
            <!-- 实体工程材料单位换算 -->
            <el-button type="primary" size="medium" class="unit-conversion-btn" v-if="currentParentName.indexOf('实体工程材料') != -1">单位换算</el-button>
            <!-- 填写实际成本 -->
            <el-button type="primary" size="medium" class="actual-cost-btn" v-else>填写实际成本</el-button>
            <!-- 表头设置组件 -->
            <dsk-table-header-setting :settingList="formColum" @settingChange="settingChange"></dsk-table-header-setting>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import ProjectSideMenu from "@/views/projectCostLedger/detail/components/ProjectSideMenu";
import { getFeedSummaryMenuTreeApi, getFeedSummaryListApi } from "@/api/projectCostLedger";
import DskTableHeaderSetting from "@/components/DskTableHeaderSetting";
import TableListCom from "@/components/TableListCom";
import { v4 } from 'uuid';
export default {
  name: "feedSummary",
  props: {
    // 项目ID
    projectId: {
      type: String,
      required: true,
      default: ""
    },
    // 详情信息
    projectDetailInfo: {
      type: Object,
      default: () => ({})
    }
  },
  watch: {
    projectDetailInfo: {
      handler(newValue) {
        this.comProjectDetailInfo = newValue ? newValue : {};
        this.init(this.comProjectDetailInfo);
      },
      deep: true,
      immediate: true
    },
    projectId: {
      handler(newValue) {
        this.comProjectId = newValue;
      },
      immediate: true
    }
  },
  components: {
    ProjectSideMenu,
    DskTableHeaderSetting,
    TableListCom
  },
  data() {
    return {
      menuOptions: {
        nodeName: "name",
        nodeValue: "name",
      },
      comProjectDetailInfo: {},
      comProjectId: "",
      defaultActive: "",
      menuTreeList: [],
      // 列表表头
      formColum: [
        { label: '序号', prop: "staticSerialNumber", type: "index", lock: true, fixed: false, uid: v4() },
      ],
      // 当前查询的数据月份
      recordDate: "",
      // 当前选中子菜单的父类名称
      currentParentName: ""
    };
  },
  //可访问data属性
  created() {

  },
  //计算集
  computed: {

  },
  //方法集
  methods: {
    async init(detail = {}) {
      try {
        const { projectId, cbStage } = detail;
        if (!projectId) return;
        await this.getFeedSummaryMenuTree({
          projectId,
          cbStage
        });
      } catch (error) {

      }
    },
    async getFeedSummaryMenuTree(params) {
      try {
        const result = await getFeedSummaryMenuTreeApi(params);
        if (result.code == 200) {
          const _tempArray = result.data;
          this.menuTreeList = _tempArray;
        }
      } catch (error) {

      }
    },
    async getFeedSummaryList(params = {}) {
      try {
        const list = await getFeedSummaryListApi(params);
        if (list.code == 200 && list.data instanceof Array) {

        }
      } catch (error) {

      }
    },
    menuSelect(currentId, currentTemp) {
      const parentName = currentTemp.parent ? this.getCurrentType(currentTemp.parent) : currentId;
      if (parentName) this.currentParentName = parentName;
    },
    getCurrentType(parent) {
      if (parent.level == 2) {
        return parent.nodeName;
      }
      if (parent.parent) {
        return this.getCurrentType(parent.parent);
      }
    },
    // 时间选择变化
    timeChange(time) {
      console.log(time);
    },
    // 表头设置变化
    async settingChange(use) {
      try {
        this.formColum = use;
      } catch (error) {

      }
    },
  },
}
</script>
<style lang="scss" scoped>
.feed-summary-container {
  width: 100%;
  height: 100%;

  .feed-summary-inner {
    width: 100%;
    height: 100%;
    display: flex;
    align-items: center;

    .left-side-menu {
      width: 220px;
      min-width: 220px;
      height: 100%;
    }
    .right-table-list-container {
      width: calc(100% - 220px);
      height: 100%;
      box-sizing: border-box;
      background: #fff;
      padding: 16px;

      ::v-deep .project-table-list-header {
        margin-bottom: 16px;
        display: flex;
        align-items: center;
        justify-content: space-between;

        .project-table-list-haeder-left {
          display: flex;
          align-items: center;
          .project-record-date {
            width: 140px;
            .el-input__inner {
              height: 32px;
              line-height: 32px;
              padding: 0px 12px;
              border-radius: 2px;
              border-color: #dcdfe6;
              font-size: 14px;
              color: #232323;
              font-weight: 350;
            }
            .el-input__suffix {
              right: 12px;
              .el-input__icon {
                line-height: 32px;
                width: auto;
              }
            }
            .el-input__prefix {
              display: none;
            }
          }
        }

        .project-table-list-haeder-right {
          display: flex;
          align-items: center;

          .actual-cost-btn,
          .unit-conversion-btn {
            height: 32px;
            display: flex;
            align-items: center;
            justify-content: center;
            padding: 0px 12px;
            background-color: #0081ff;
            border-color: #0081ff;
            border-radius: 4px;
            color: #fff;
            font-size: 14px;
            font-weight: 350;
            margin-right: 16px;
          }
        }
      }
    }
  }
}
</style>
